#ifndef	_ENCODE_PARAMS_HEADER
#define	_ENCODE_PARAMS_HEADER
#include "windows.h"
//Ƶ
enum EVideoEncoder
{
	VE_X264,				//x264 
	VE_CUDA,				//nvidia CUDA Ӳٱ
	VE_NVENC,				//nvidia NVENC Ӳ
	VE_INTEL				//intel Լٱ
};
static const char * const video_encoder_names[] = { "x264", "nvcuda", "nvenc", "intel", 0 };

//Ƶãprofile
enum EVideoProfile
{
	VF_Auto,
	VF_BaseLine,
	VF_Main,
	VF_High
};
static const char * const video_profile_names[] = { "auto", "baseline", "main", "high", 0 };

//ڸƵ Preset 
typedef int EVideoPreset;
enum EVideoPreset_x264
{
	VP_x264_UltraFast,
	VP_x264_SuperFast,
	VP_x264_VeryFast,
	VP_x264_Faster,
	VP_x264_Fast,
	VP_x264_Medium,
	VP_x264_Slow,
	VP_x264_Slower,
	VP_x264_VerySlow,
	VP_x264_Placebo
};
static const char * const video_preset_x264_names[] = { "UltraFast", "SuperFast", "VeryFast", "Faster", "Fast", 
														"Medium", "Slow", "Slower", "VerySlow", "Placebo", 0 };

enum EVideoPreset_Cuda
{
	VP_Cuda_PSP,		//width 320  height 240
	VP_Cuda_iPod,		//width 320  height 240
	VP_Cuda_AVCHD,		//width 1920 height 1080
	VP_Cuda_BD,			//width 1920 height 1080
	VP_Cuda_HDV1440,	//width 1440 height 1080
	VP_Cuda_ZuneHD,		//width 720  height 480
	VP_Cuda_FlipCam
};
static const char * const video_preset_cuda_names[] = { "PSP", "iPod", "AVCHD", "BlurayDisk", "HDV1440", "ZuneHD", "FlipCam", 0 };

enum EVideoPreset_Nvenc
{
	VP_Nvenc_Default,
	VP_Nvenc_HighPerformance,
	VP_Nvenc_HighQuality,
	VP_Nvenc_BlurayDisk,
	VP_Nvenc_LowLatencyDefault,
	VP_Nvenc_LowLatencyHP,
	VP_Nvenc_LowLatencyHQ,
	VP_Nvenc_LosslessDefault,
	VP_Nvenc_LosslessHP
};
static const char * const video_preset_nvenc_names[] = { "Default", "HighPerformance", "HighQuality", "BlurayDisk", "LowLatencyDefault", 
														"LowLatencyHP", "LowLatencyHQ", "LosslessDefault", "LosslessHP", 0 };

enum EVideoPreset_Intel
{
	VP_Intel_Speed,
	VP_Intel_Balanced,
	VP_Intel_Quality
};
static const char * const video_preset_intel_names[] = { "Speed", "Balanced", "Quality", 0 };

//ƵʿƷʽ
enum EVideoRateMode
{
	VR_AverageBitrate,		//ƽ(ABR)		
							//x264 ʹ X264_RC_ABRƽ
							//Nvenc	NV_ENC_PARAMS_RC_VBR
							//Cuda	RC_VBR

	VR_VariableBitrate,		//ɱ(VBR)		
							//x264 ʹ X264_RC_ABRƽ п
							//Nvenc	NV_ENC_PARAMS_RC_VBR
							//Cuda	RC_VBR

	VR_ConstantBitrate,		//̶(CBR)		
							//x264 ʹ X264_RC_CRF п
							//Nvenc	NV_ENC_PARAMS_RC_CBR
							//Cuda	RC_CBR

	VR_ConstantQP,			//㶨(CQP)		
							//x264 ʹ X264_RC_CQP㶨
							//Nvenc	NV_ENC_PARAMS_RC_CBR,  VBV ֵʹ NV_ENC_PARAMS_RC_VBR_MINQP
							//Cuda	RC_CQP / RC_VBR_MINQP
};

//Ƶļĸʽ
enum	EFileContainer
{
	Mix_FLV,
	Mix_MP4,
	Mix_AVI,

	Mix_RTMP,
	Mix_RdCloud,

	Vid_264,	//H264װƵ
	Aud_ONLY,	//AAC/MP3ļƵ

	File_Container_TypeCount
};

enum	EAudioInSamples		//ƵĲƵ
{
	Aud_Inp_Samp_11025	= 11025,		//11Khz
	Aud_Inp_Samp_22050	= 22050,		//22Khz
	Aud_Inp_Samp_44100	= 44100,		//44Khz
	Aud_Inp_Samp_48000	= 48000		//48Khz
};

//Ƶ
enum	EAudioEncoder
{
	Aud_Enc_AAC,
	Aud_Enc_PCM,
	//Aud_Enc_Mp3,
};

enum	EVideoCSP
{
	Vid_CSP_I420,			//IYUV  /* yuv 4:2:0 planar */	YYYY YYYY UU VV
	Vid_CSP_YV12,			//  /* yvu 4:2:0 planar */	YYYY YYYY VV UU
	Vid_CSP_NV12,			//  /* yuv 4:2:0, with one y plane and one packed u+v */	YYYY YYYY UVUV
	Vid_CSP_NV21,			//  /* yuv 4:2:0, with one y plane and one packed v+u */	YYYY YYYY VUVU
	Vid_CSP_I422,			//  /* yuv 4:2:2 planar */	YYYY YYYY UUUU VVVV

	Vid_CSP_YV16,			//  /* yvu 4:2:2 planar */	YYYY YYYY VVVV UUUU
	Vid_CSP_NV16,			//  /* yuv 4:2:2, with one y plane and one packed u+v */	YYYY YYYY UVUVUVUV
	Vid_CSP_YUY2,			//
	Vid_CSP_UYVY,
	Vid_CSP_V210,			//0x0008  /* 10-bit yuv 4:2:2 packed in 32 */

	Vid_CSP_I444,			//0x0009  /* yuv 4:4:4 planar */
	Vid_CSP_YV24,			//0x000a  /* yvu 4:4:4 planar */
	Vid_CSP_AYUV,
	Vid_CSP_RGB,			//0x000d  /* packed rgb 24bits   */
	Vid_CSP_BGR,			//0x000b  /* packed bgr 24bits   */

	Vid_CSP_ARGB,			//0x000c  /* packed bgr 32bits   */	A8R8G8B8
	Vid_CSP_ARGB10,			//0x000c  /* packed bgr 32bits   */	A2R10G10B10
};

static const char * const video_color_space_names[] = { "I420/IYUV", "YV12", "NV12", "NV21", "I422", 
														"YV16", "NV16", "YUY2", "UYVY", "V210",
														"I444", "YV24", "AYUV", "RGB", "BGR", 
														"ARGB", "ARGB10", 0 };

typedef	struct	SEncStatusConnectFail
{
	DWORD		dwErrorCode;	//
	DWORD		dwTryLaterMS;	//ڶٺ᳢ٴӡֵΪ 0xFFFFFFFF ʾٴγ
}*PSEncStatusConnectFail;

typedef	struct	SEncStatusUploadBitrate
{
	INT64		iConnectUploadMSeconds;	//ǰѾϴƵʱ룩
	INT64		iTotalUploadMSeconds;	//ۼϴƵʱ룩
	DWORD		uCurrentUploadBitrate;	//ǰϴ
	DWORD		uAverageUploadBitrate;	//ƽϴʣһӣ
}*PSEncStatusUploadBitrate;

typedef	struct	SEncStatusDiscardPacks
{
	INT64		iDiscardStartMSeconds;	//֡ʼʱ䣨룩
	INT64		iDiscardMSeconds;		//ʱ룩
	DWORD		uDiscardFrames;			//֡
	DWORD		uAverageUploadBitrate;	//ƽϴʣһӣ
}*PSEncStatusDiscardPacks;

typedef	struct	SEncStatusEncodeFps
{
	INT64		iRecordTime;	//ӿʼ¼Ƶǰʱ룩
	INT64		iInpFrameNum;	//ǰ֡ıš
	INT64		iEncFrameNum;	//ǰڱ֡ıš
	INT64		iEncFrameCount;	//ʵʱɵ֡֡
	float		fAvgEncodeFps;	//ƽı֡ʡ
	float		fCurEncodeFps;	//ǰ֡ʡ
	float		fAvgInputFps;	//ƽ֡ʡ
	float		fCurInputFps;	//ǰ֡ʡ

}*PSEncStatusEncodeFps;

struct	SEncoderSaveFile
{
	EFileContainer	eContainer;
	LPCWSTR			szSavePath;
	LPCWSTR			szTitle;
	LPCWSTR			szContent;

	union
	{
		INT64	iSplitSize;
		struct
		{
			DWORD	dwDelaySecond;
			BOOL	bAdaptiveNetwork;
		};
	};
};




//뼰桢ϴ״̬ͨص֪ͨϲߡ
enum	IEncoder_ENotify
{
	eEncNotifySuccess,			//ɹͨҪֵ֪ͨ

	eEncNotifyStarted,			//Ѿʼ

	eEncNotifyStoped,			//Ѿֹͣ
								//dwValue	= 루DWORD
								//ptrValue	= 0

	eEncNotifyEncodeError,		//бʧܡ
								//dwValue	= 룻
								//ptrValue	= 0

	eEncNotifyEncodeFps,		//֡ʵϢԼÿ㲢֪ͨһΡ
								//dwValue	= 0
								//ptrValue	= PSEncStatusEncodeFps

	eEncNotifyWriteFileFail,	//дļʧܡ
								//dwValue	= ǰļ Index
								//ptrValue	= 루DWORD

	eEncNotifyDisconnected,		//ϴʱӱϿ
								//dwValue	= ǰļ Index
								//ptrValue	= 루DWORD

	eEncNotifyReConnectStart,	//ʼӡ
								//dwValue	= ǰļ Index
								//ptrValue	= DWORD1ʼ

	eEncNotifyReConnectDone,	//ӳɹ
								//dwValue	= ǰļ Index
								//ptrValue	= DWORD
								//صغ0´ζϿʱִ1ʼ

	eEncNotifyReConnectFail,	//ʧ
								//dwValue	= ǰļ Index
								//ptrValue	= PSEncStatusConnectFail

	eEncNotifyUploadBitrate,	//ǰϴʣԼÿ㲢֪ͨһΡ
								//dwValue	= ǰļ Index
								//ptrValue	= PSEncStatusUploadBitrate

	eEncNotifyDiscardPacks,		//Ϊϴ˲ֱƵݡ
								//dwValue	= ǰļ Index
								//ptrValue	= PSEncStatusDiscardPacks

	eEncNotifyDiscardFrame,		//Ϊ뻺һ֡档
								//dwValue	= Ϊ֡ţ
								//ptrValue	= 0

	eEncNotifyResetBitrate,		//ΪϴԶƵ
								//dwValue	= Ϊʣ
								//ptrValue	= 0

	eEncNotifyResetPreset,		//Ϊ뻺ԶƵı( x264 )
								//dwValue	= Ϊ EVideoPreset
								//ptrValue	= 0

	eEncNotify_AcceditDone,		//Ȩ֤ɡ
								//dwValue	= TRUE  FALSE
								//ptrValue	= LPCWSTR ʧܵ˵

	eEncNotify_GetCloudFail,	//ȡ Mix_RdCloud ֱַʧ
								//dwValue	= ǰļ Index
								//ptrValue	= LPCWSTR ʧܵ˵

	eEncNotify_Count
};


//ص֪ͨϲߵǰı״̬
typedef	VOID	( WINAPI* fnEncoderNotifyCB )( IEncoder_ENotify	eNotify,		//֪ͨ
												DWORD			dwValue,		//ֵ״̬ûֵΪ0
												DWORD_PTR		ptrValue,		//
												LPVOID			pCbParam	//ûѵͨ GvStartEncode õ pCbUserParam ԭء
												);

#endif